#include <amxmodx>
#include <zombieplague>
#include <nvault>

new g_Vault
new g_sName[33][35], g_sZombiesID[33]

public plugin_init()
{
	register_plugin( "Save Zombie" , "1.0" , "zmd94" );
	
	register_event("DeathMsg", "event_DeathMsg", "a", "1>0")
}

public plugin_cfg()
{
	g_Vault = nvault_open( "save_zombie");

	if ( g_Vault == INVALID_HANDLE )
		set_fail_state( "Error opening nVault" );
}

public plugin_end()
{
	nvault_close( g_Vault );
}

public client_authorized(id)
{
	get_user_name(id, g_sName[id], charsmax(g_sName))
	LoadZombie(id)
}

public client_disconnect(id)
{
	g_sZombiesID[id] = zp_get_user_zombie_class(id)
	SaveZombie(id)
}

public SaveZombie(id)
{
	new szZombie[7], szKey[40]

	formatex( szKey , charsmax( szKey ) , "%sZOMBIEID" , g_sName[id] );
	formatex( szZombie , charsmax( szZombie ) , "%d" , g_sZombiesID[id] );
	
	nvault_set( g_Vault , szKey , szZombie );
}

public LoadZombie(id)
{
	new szKey[40];
	formatex( szKey , charsmax( szKey ) , "%sZOMBIEID" , g_sName[id] );
	new iZombieID = nvault_get( g_Vault , szKey );

	if ( iZombieID )
	{
		g_sZombiesID[id] = iZombieID
		nvault_remove( g_Vault , szKey );
	}
	else
	{
		g_sZombiesID[id] = 0
	}
}

public zp_user_infected_pre(id)
{
	if(zp_get_user_next_class(id) != -1)
	{
		g_sZombiesID[id] = zp_get_user_next_class(id)
	}
	else
	{
		zp_set_user_zombie_class(id, g_sZombiesID[id])
	}
}

public event_DeathMsg()
{
	new iKiller; iKiller = read_data(1)
	new iVictim; iVictim = read_data(2)

	if(iVictim == iKiller || !is_user_alive(iKiller))
		return
	
	g_sZombiesID[iVictim] = zp_get_user_zombie_class(iVictim)
}